package fr.itsonus.bousoleplussbackend.payload.response;

import com.fasterxml.jackson.annotation.JsonInclude;
import org.springframework.http.HttpStatus;
import org.springframework.http.HttpStatusCode;
import org.springframework.http.ResponseEntity;

import java.util.List;

public record ApiError(String message, @JsonInclude(JsonInclude.Include.NON_EMPTY) List<FieldError> fieldErrors) {

    public ApiError(String message) {
        this(message, List.of());
    }

    public ResponseEntity<ApiError> toResponse(HttpStatus status) {
        return ResponseEntity.status(status).body(this);
    }

    public ResponseEntity<ApiError> toResponse(HttpStatusCode status) {
        return ResponseEntity.status(status).body(this);
    }

    public record FieldError(String detail, @JsonInclude(JsonInclude.Include.NON_EMPTY) String... fields) {
    }
}
